%if 0%{?centos} == 7 || 0%{?rhel} == 7
# On CentOS 7 pywcs fails to build properly. It causes errors in the check
# script /usr/lib/rpm/check-buildroot. Thus, disable that step on CentOS 7.
%define __arch_install_post /usr/lib/rpm/check-rpaths
%endif

%define stscipython stscipython
%define stscipython_version %{version}
%define stsci_distutils stsci.distutils
%define stsci_distutils_version 0.3.7
%define stsci_tools stsci.tools
%define stsci_tools_version 3.4
%define stsci_ndimage stsci.ndimage
%define stsci_ndimage_version 0.10.0
%define stsci_convolve stsci.convolve
%define stsci_convolve_version 2.2.0
%define stsci_stimage stsci.stimage
%define stsci_stimage_version 0.2
%define stsci_imagestats stsci.imagestats
%define stsci_imagestats_version 1.4
%define stsci_imagemanip stsci.imagemanip
%define stsci_imagemanip_version 1.1
%define stsci_image stsci.image
%define stsci_image_version 2.1
%define stsci_sphinxext stsci.sphinxext
%define stsci_sphinxext_version 1.2.1
%define stsci_numdisplay stsci.numdisplay
%define stsci_numdisplay_version 1.6
%define pywcs pywcs
%define pywcs_version 1.12
%define stwcs stwcs
%define stwcs_version 1.1.2
%define pysynphot pysynphot
%define pysynphot_version 0.9.7
%define pydrizzle pydrizzle
%define pydrizzle_version 6.4.3
%define nictools nictools
%define nictools_version 1.1.1
%define calcos calcos
%define calcos_version 3.0
%define astrolib_coords astrolib.coords
%define astrolib_coords_version 0.39.5
%define wfpc2tools wfpc2tools
%define wfpc2tools_version 1.0.2
%define wfc3tools wfc3tools
%define wfc3tools_version 1.3
%define stistools stistools
%define stistools_version 1.0.2
%define reftools reftools
%define reftools_version 1.6.5
%define pyraf pyraf
%define pyraf_version 2.1.11
%define opuscoords opuscoords
%define opuscoords_version 1.0.1
%define multidrizzle multidrizzle
%define multidrizzle_version 3.4.2
%define fitsblender fitsblender
%define fitsblender_version 0.2.3
%define drizzlepac drizzlepac
%define drizzlepac_version 1.1.16
%define costools costools
%define costools_version 1.2
%define acstools acstools
%define acstools_version 1.7.3

Name:           scisoft-python-stscipython
Version:        2.15.1
Release:        1%{?dist}
Summary:        Python routines and C extensions for astronomical data analysis
License:        Distributable
Distribution:   Scisoft
Group:          Applications/Scientific
Packager:       Carlos Guirao <cguirao@eso.org>
URL:            http://www.stsci.edu/institute/software_hardware/pyraf/stsci_python

Source0:   https://files.pythonhosted.org/packages/source/s/%{stscipython}/%{stscipython}-%{stscipython_version}.tar.gz
Source1:   https://files.pythonhosted.org/packages/source/s/%{stsci_distutils}/%{stsci_distutils}-%{stsci_distutils_version}.tar.gz
Source2:   https://files.pythonhosted.org/packages/source/s/%{stsci_tools}/%{stsci_tools}-%{stsci_tools_version}.tar.gz
Source3:   https://files.pythonhosted.org/packages/source/s/%{stsci_ndimage}/%{stsci_ndimage}-%{stsci_ndimage_version}.tar.gz
Source4:   https://files.pythonhosted.org/packages/source/s/%{stsci_convolve}/%{stsci_convolve}-%{stsci_convolve_version}.tar.gz
Source5:   https://files.pythonhosted.org/packages/source/s/%{stsci_stimage}/%{stsci_stimage}-%{stsci_stimage_version}.tar.gz
Source6:   https://files.pythonhosted.org/packages/source/s/%{stsci_imagestats}/%{stsci_imagestats}-%{stsci_imagestats_version}.tar.gz
Source7:   https://files.pythonhosted.org/packages/source/s/%{stsci_imagemanip}/%{stsci_imagemanip}-%{stsci_imagemanip_version}.tar.gz
Source8:   https://files.pythonhosted.org/packages/source/s/%{stsci_image}/%{stsci_image}-%{stsci_image_version}.tar.gz
Source9:   https://files.pythonhosted.org/packages/source/s/%{stsci_sphinxext}/%{stsci_sphinxext}-%{stsci_sphinxext_version}.tar.gz
Source10:  https://files.pythonhosted.org/packages/source/s/%{stsci_numdisplay}/%{stsci_numdisplay}-%{stsci_numdisplay_version}.tar.gz
Source11:  https://files.pythonhosted.org/packages/source/p/%{pywcs}/%{pywcs}-%{pywcs_version}.tar.gz
Source12:  https://files.pythonhosted.org/packages/source/s/%{stwcs}/%{stwcs}-%{stwcs_version}.zip
Source13:  https://files.pythonhosted.org/packages/source/p/%{pysynphot}/%{pysynphot}-%{pysynphot_version}.tar.gz
Source14:  https://files.pythonhosted.org/packages/source/p/%{pydrizzle}/%{pydrizzle}-%{pydrizzle_version}.tar.gz
Source15:  https://files.pythonhosted.org/packages/source/n/%{nictools}/%{nictools}-%{nictools_version}.tar.gz
Source16:  https://files.pythonhosted.org/packages/source/c/%{calcos}/%{calcos}-%{calcos_version}.tar.gz
Source17:  https://files.pythonhosted.org/packages/source/a/%{astrolib_coords}/%{astrolib_coords}-%{astrolib_coords_version}.tar.gz
Source18:  https://files.pythonhosted.org/packages/source/w/%{wfpc2tools}/%{wfpc2tools}-%{wfpc2tools_version}.tar.gz
Source19:  https://files.pythonhosted.org/packages/source/w/%{wfc3tools}/%{wfc3tools}-%{wfc3tools_version}.tar.gz
Source20:  https://files.pythonhosted.org/packages/source/s/%{stistools}/%{stistools}-%{stistools_version}.tar.gz
Source21:  https://files.pythonhosted.org/packages/source/r/%{reftools}/%{reftools}-%{reftools_version}.tar.gz
Source22:  https://files.pythonhosted.org/packages/source/p/%{pyraf}/%{pyraf}-%{pyraf_version}.tar.gz
Source23:  https://files.pythonhosted.org/packages/source/o/%{opuscoords}/%{opuscoords}-%{opuscoords_version}.tar.gz
Source24:  https://files.pythonhosted.org/packages/source/m/%{multidrizzle}/%{multidrizzle}-%{multidrizzle_version}.tar.gz
Source25:  https://files.pythonhosted.org/packages/source/f/%{fitsblender}/%{fitsblender}-%{fitsblender_version}.tar.gz
Source26:  https://files.pythonhosted.org/packages/source/d/%{drizzlepac}/%{drizzlepac}-%{drizzlepac_version}.tar.gz
Source27:  https://files.pythonhosted.org/packages/source/c/%{costools}/%{costools}-%{costools_version}.zip
Source28:  https://files.pythonhosted.org/packages/source/a/%{acstools}/%{acstools}-%{acstools_version}.tar.gz

BuildRequires:  python2-devel
BuildRequires:  python-d2to1
BuildRequires:  numpy
BuildRequires:  python-astropy
BuildRequires:  pyfits
BuildRequires:  libX11-devel
Requires:       python
Requires:       numpy
Requires:       python-astropy
Requires:       pyfits

%description
stsci_python is a library of Python routines and C extensions that has been
developed to provide a general astronomical data analysis infrastructure.
It includes the following:
    PyRAF, an environment for running IRAF tasks without using the IRAF CL
    MultiDrizzle, a task for combining dithered STScI images
    PyFITS, used to read FITS images and tables into numpy or numarray
    objects and to manipulate FITS headers
    pysynphot is a synthetic photometry package (still in development)
    designed to replace STSDAS.SYNPHOT. It is suitable for library or
    interactive use.
    Numdisplay, used to visualize numpy array objects using image display
    tools like ds9 and ximtool


%prep
%setup -n %{stscipython}-%{stscipython_version}
%setup -T -b  1 -n %{stsci_distutils}-%{stsci_distutils_version}
%setup -T -b  2 -n %{stsci_tools}-%{stsci_tools_version}
%setup -T -b  3 -n %{stsci_ndimage}-%{stsci_ndimage_version}
%setup -T -b  4 -n %{stsci_convolve}-%{stsci_convolve_version}
%setup -T -b  5 -n %{stsci_stimage}-%{stsci_stimage_version}
%setup -T -b  6 -n %{stsci_imagestats}-%{stsci_imagestats_version}
%setup -T -b  7 -n %{stsci_imagemanip}-%{stsci_imagemanip_version}
%setup -T -b  8 -n %{stsci_image}-%{stsci_image_version}
%setup -T -b  9 -n %{stsci_sphinxext}-%{stsci_sphinxext_version}
%setup -T -b 10 -n %{stsci_numdisplay}-%{stsci_numdisplay_version}
%setup -T -b 11 -n %{pywcs}-%{pywcs_version}
%setup -T -b 12 -n %{stwcs}-%{stwcs_version}
%setup -T -b 13 -n %{pysynphot}-%{pysynphot_version}
%setup -T -b 14 -n %{pydrizzle}-%{pydrizzle_version}
%setup -T -b 15 -n %{nictools}-%{nictools_version}
%setup -T -b 16 -n %{calcos}-%{calcos_version}
%setup -T -b 17 -n %{astrolib_coords}-%{astrolib_coords_version}
%setup -T -b 18 -n %{wfpc2tools}-%{wfpc2tools_version}
%setup -T -b 19 -n %{wfc3tools}-%{wfc3tools_version}
%setup -T -b 20 -n %{stistools}-%{stistools_version}
%setup -T -b 21 -n %{reftools}-%{reftools_version}
%setup -T -b 22 -n %{pyraf}-%{pyraf_version}
%setup -T -b 23 -n %{opuscoords}-%{opuscoords_version}
%setup -T -b 24 -n %{multidrizzle}-%{multidrizzle_version}
%setup -T -b 25 -n %{fitsblender}-%{fitsblender_version}
%setup -T -b 26 -n %{drizzlepac}-%{drizzlepac_version}
%setup -T -b 27 -n %{costools}-%{costools_version}
%setup -T -b 28 -n %{acstools}-%{acstools_version}

# The following CFLAGS override is necessary to add the GCC -fdebug-prefix-map
# option. Without it we would be compiling binary objects with paths pointing to
# the $RPM_BUILD_ROOT in the debug symbols. That is both wrong and would cause
# the check-buildroot script (that is automatically run by RPM) to fail.
%define scisoftflags %{optflags} -fdebug-prefix-map=%{buildroot}%{python2_sitearch}=%{python2_sitearch}
%define py2_build CFLAGS="%{scisoftflags}" %{__python2} %{py_setup} %{?py_setup_args} build --executable="%{__python2} %{py2_shbang_opts}"

%build
export PYTHONPATH=%{buildroot}%{python2_sitelib}:%{buildroot}%{python2_sitearch}
cd %{_builddir}/%{stsci_distutils}-%{stsci_distutils_version}
%py2_build
# Note: have to install and patch the stsci.distutils package that will be
# needed by subsequent packages. This is wiped and cleanly installed again later
# in the install section of this spec file.
%py2_install
touch %{buildroot}%{python2_sitelib}/stsci/__init__.py
cd %{_builddir}/%{stsci_tools}-%{stsci_tools_version}
%py2_build
cd %{_builddir}/%{stsci_ndimage}-%{stsci_ndimage_version}
%py2_build
cd %{_builddir}/%{stsci_convolve}-%{stsci_convolve_version}
%py2_build
cd %{_builddir}/%{stsci_stimage}-%{stsci_stimage_version}
%py2_build
cd %{_builddir}/%{stsci_imagestats}-%{stsci_imagestats_version}
%py2_build
cd %{_builddir}/%{stsci_imagemanip}-%{stsci_imagemanip_version}
%py2_build
cd %{_builddir}/%{stsci_image}-%{stsci_image_version}
%py2_build
cd %{_builddir}/%{stsci_sphinxext}-%{stsci_sphinxext_version}
%py2_build
cd %{_builddir}/%{stsci_numdisplay}-%{stsci_numdisplay_version}
%py2_build
cd %{_builddir}/%{pywcs}-%{pywcs_version}
%py2_build
# Have to apply a similar workaround for pywcs as for stsci.distutils. This is
# necessary to be able to build drizzlepac, which depends on pywcs.
%py2_install
cd %{_builddir}/%{stwcs}-%{stwcs_version}
%py2_build
cd %{_builddir}/%{pysynphot}-%{pysynphot_version}
%py2_build
cd %{_builddir}/%{pydrizzle}-%{pydrizzle_version}
%py2_build
cd %{_builddir}/%{nictools}-%{nictools_version}
%py2_build
cd %{_builddir}/%{calcos}-%{calcos_version}
%py2_build
cd %{_builddir}/%{astrolib_coords}-%{astrolib_coords_version}
%py2_build
cd %{_builddir}/%{wfpc2tools}-%{wfpc2tools_version}
%py2_build
cd %{_builddir}/%{wfc3tools}-%{wfc3tools_version}
%py2_build
cd %{_builddir}/%{stistools}-%{stistools_version}
%py2_build
cd %{_builddir}/%{reftools}-%{reftools_version}
%py2_build
cd %{_builddir}/%{pyraf}-%{pyraf_version}
%py2_build
cd %{_builddir}/%{opuscoords}-%{opuscoords_version}
%py2_build
cd %{_builddir}/%{multidrizzle}-%{multidrizzle_version}
%py2_build
cd %{_builddir}/%{fitsblender}-%{fitsblender_version}
%py2_build
cd %{_builddir}/%{drizzlepac}-%{drizzlepac_version}
%py2_build
cd %{_builddir}/%{costools}-%{costools_version}
%py2_build
cd %{_builddir}/%{acstools}-%{acstools_version}
%py2_build
cd %{_builddir}/%{stscipython}-%{stscipython_version}
%py2_build

%install
export PYTHONPATH=%{buildroot}%{python2_sitelib}
cd %{_builddir}/%{stsci_distutils}-%{stsci_distutils_version}
%py2_install
# Have to workaround installation problems with stsci.tools when stsci.distutils
# is not already installed into the system paths.
touch %{buildroot}%{python2_sitelib}/stsci/__init__.py
cd %{_builddir}/%{stsci_tools}-%{stsci_tools_version}
%py2_install
cd %{_builddir}/%{stsci_ndimage}-%{stsci_ndimage_version}
%py2_install
cd %{_builddir}/%{stsci_convolve}-%{stsci_convolve_version}
%py2_install
cd %{_builddir}/%{stsci_stimage}-%{stsci_stimage_version}
%py2_install
cd %{_builddir}/%{stsci_imagestats}-%{stsci_imagestats_version}
%py2_install
cd %{_builddir}/%{stsci_imagemanip}-%{stsci_imagemanip_version}
%py2_install
cd %{_builddir}/%{stsci_image}-%{stsci_image_version}
%py2_install
cd %{_builddir}/%{stsci_sphinxext}-%{stsci_sphinxext_version}
%py2_install
cd %{_builddir}/%{stsci_numdisplay}-%{stsci_numdisplay_version}
%py2_install
cd %{_builddir}/%{pywcs}-%{pywcs_version}
%py2_install
cd %{_builddir}/%{stwcs}-%{stwcs_version}
%py2_install
cd %{_builddir}/%{pysynphot}-%{pysynphot_version}
%py2_install
cd %{_builddir}/%{pydrizzle}-%{pydrizzle_version}
%py2_install
cd %{_builddir}/%{nictools}-%{nictools_version}
%py2_install
cd %{_builddir}/%{calcos}-%{calcos_version}
%py2_install
cd %{_builddir}/%{astrolib_coords}-%{astrolib_coords_version}
%py2_install
cd %{_builddir}/%{wfpc2tools}-%{wfpc2tools_version}
%py2_install
cd %{_builddir}/%{wfc3tools}-%{wfc3tools_version}
%py2_install
cd %{_builddir}/%{stistools}-%{stistools_version}
%py2_install
cd %{_builddir}/%{reftools}-%{reftools_version}
%py2_install
cd %{_builddir}/%{pyraf}-%{pyraf_version}
%py2_install
cd %{_builddir}/%{opuscoords}-%{opuscoords_version}
%py2_install
cd %{_builddir}/%{multidrizzle}-%{multidrizzle_version}
%py2_install
cd %{_builddir}/%{fitsblender}-%{fitsblender_version}
%py2_install
cd %{_builddir}/%{drizzlepac}-%{drizzlepac_version}
%py2_install
cd %{_builddir}/%{costools}-%{costools_version}
%py2_install
cd %{_builddir}/%{acstools}-%{acstools_version}
%py2_install
cd %{_builddir}/%{stscipython}-%{stscipython_version}
%py2_install
# Cleaning up temporary file created in the earlier workaround.
test -s && (rm %{buildroot}%{python2_sitelib}/stsci/__init__.py || exit 1)

%files
%{python2_sitelib}/*
%{python2_sitearch}/*
%{_bindir}/*

%changelog
* Thu Feb 22 2018 <aszostak@partner.eso.org> 2.15.1
- Migrated stsci_python to the automated build system.
- Renamed the package it to better follow naming conventions.
- Disabled check-buildroot for CentOS 7 due to pywcs failure.

* Fri Oct 21 2016 <aszostak@partner.eso.org> 2.15.1-1
- Fixed spec file to produce a properly pre-built binary package.
- Needed to add missing dependencies.

* Mon May 05 2014 <cguirao@eso.org>
- adapted to PIP

* Thu Nov 14 2013 <cguirao@eso.org>
- adapted to SCISOFT 
